using System;
using System.Collections.Generic;
using ReactiveUI;
using CheckArticlesForSpam.Models;
using Avalonia.Media;
using System.Linq;
using System.Net;
using System.IO;
using System.Text;
using System.Net.Http;
using Microsoft.Extensions.Options;
using RestSharp;
using Newtonsoft.Json;


namespace ChecksArticlesForSpam.ViewModels
{
	public class ArticleDataPageViewModel : ReactiveObject
	{
		Article articleItem;
		string textArticle;
        string titleArticle;
		string message = "";
        private IBrush colorMessage;

        public IBrush ColorMessage { get => colorMessage; set => this.RaiseAndSetIfChanged(ref colorMessage, value); }
        public Article ArticleItem { get => articleItem; set => articleItem = value; }
        public string TextArticle { get => textArticle; set => this.RaiseAndSetIfChanged(ref textArticle, value); }
        public string TitleArticle { get => titleArticle; set => this.RaiseAndSetIfChanged(ref titleArticle, value); }
        public string Message { get => message; set => this.RaiseAndSetIfChanged(ref message, value); }

        public ArticleDataPageViewModel()
		{
			articleItem = new Article();
		}
        public ArticleDataPageViewModel(Article articleItem)
		{
			this.articleItem = articleItem;
			textArticle = articleItem.TextArticle;
			titleArticle = articleItem.Title;
		}
        public Dictionary<string, Article> GetDataArticle(User currentUser)
        {
            if (string.IsNullOrEmpty(TitleArticle)) return new Dictionary<string, Article> { { "1", null } }; 
            else if (TitleArticle.Length > 100) return new Dictionary<string, Article> { { "2", null } };
            else
            {
                ArticleItem.TextArticle = TextArticle;
                ArticleItem.UserId = currentUser.IdUser;
                if (ArticleItem.CheckSpam == null) ArticleItem.CheckSpam = false;
                ArticleItem.Title = TitleArticle;
                return new Dictionary<string, Article> { { "3", ArticleItem } }; ;
            }
        }
        public void CheckArticleForSpam(MlgTeamContext context)
        {
            var endpoint = "http://127.0.0.1:5000";
            var client = new RestClient(endpoint);
            var request = new RestRequest();
            Dictionary<string, string> body = new() { { "Text", TextArticle } };
            var jsonBody = JsonConvert.SerializeObject(body);
            request.AddJsonBody(jsonBody);
            var response = client.Post(request);
            var code = response.Content;
            var result = JsonConvert.DeserializeObject<APIResponce>(code);
            if (result.Type == " ")
            {
                Message = result.Type + $",  - {Math.Round(result.Probability, 5)} ";
                ColorMessage = Brushes.Green;
                ArticleItem.CheckSpam = true;
                context.SaveChanges();
            }
            else
            {
                Message = result.Type + $",  - {Math.Round(result.Probability, 5)} ";
                ColorMessage = Brushes.Red;
                ArticleItem.CheckSpam = false;
                context.SaveChanges();
            }
        }
    }
}